/**
 * \file: main.cpp
 *
 */

#include <iostream>
#include <sstream>
#include <string>
#include <stdlib.h>
#include <time.h>

#include "player.h"

using std::cin;
using std::cout;
using std::cerr;
using std::endl;

/// microsecond sleep
/// @param t - time to sleep in useconds
//  @return -1 if signal has been received, 0 otherwise
int uSleep(int usec) {
    struct timespec tim = { 0, usec*1000L }, trem;
    return nanosleep(&tim, &trem);
}

int main(int argc, char ** argv) {
    if(argc != 4) {
        cerr << "Usage: " << argv[0] << " <hostname> <port> burglar|cop>" << endl;
        return 1;;
    }

    // processing the command line arguments
    std::stringstream ss(argv[2]);
    int port;
    ss >> port;	// first argument is the port number

    try {
        // starting the player
        Player pl(argv[1], port, std::string(argv[3]) == "burglar" ? Player::burglar : Player::cop);
        cerr << argv[3] << ": " << pl.getx() <<" " << pl.gety() << endl;
    
        while(1) {
            uSleep(100);	// just for slowing down
            int r = rand() % (Player::right + 1);
            Player::direction d;
            if (r == 0) d = Player::up;
            else if (r==1) d = Player::down;
            else if (r==2) d = Player::left;
            else d = Player::right;
            char *buffer = pl.move(d);
#ifdef DEBUG
            cout << "dir:" << r << " typ:" << pl.gettyp() << " ret:" << buffer;	
#endif
            delete[] buffer;
        }
    } catch (std::runtime_error &e) {
	cerr << e.what() << endl;
    }
    return 0;
}
